/////////////////////////////////////////////////////////
//      MENNO EQUIPAMENTOS PARA ESCRITORIO LTDA        //
/////////////////////////////////////////////////////////
// Cdigo-fonte em Linguagem Delphi Object Pascal      //
// Objetivo: Demonstrao de utilizao das funes    //
//           da DLL ghdl32.dll que  responsvel pelo  //
//           acionamento da GAVETA MENNO               //
//                                                     //
// Ultima reviso:  05/12/02                           //
// Observaes: A DLL ghdl32.dll e libserial.dll devem //
//              estar no mesmo diretrio do executvel //
//              ou nos seguintes diretrios            //
//              \Windows  ou \Windows\system           //
//              \WinNT    ou \WinNT\system             //
////////////////////////////////////////////////////////'
//     Este codigo-fonte pode ser copiado livremente   //
//     e incorporado a softwares que utilizem as       //
//     GAVETAS MENNO MGI                               //
////////////////////////////////////////////////////////'

unit Mgopen1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,Ghdl32, Gauges;

type
  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    Button3: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Timer1: TTimer;
    Label8: TLabel;
    GroupBox_Funcao: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Gauge2: TGauge;
    Gauge1: TGauge;
    Label2: TLabel;
    Label7: TLabel;
    Image_Logo: TImage;
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  serial: integer;
  funcao : integer;
implementation
Function GavetaConfigura (pulso,min : integer): integer; stdcall; external 'Ghdl32.dll';
Function DriverGaveta (p,f : integer) :integer; stdcall; external 'Ghdl32.dll';

{$R *.DFM}

procedure TForm1.RadioGroup1Click(Sender: TObject);
var
p1,m1: integer;

begin
     serial := radiogroup1.itemindex + 1;
     DriverGaveta (serial, Gaveta_inicializa);
     p1:=150;
     m1:=3500;
     GavetaConfigura (p1,m1 );
     timer1.enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   x: integer;
begin
     Button1.Enabled := False;
     DriverGaveta (serial,Gaveta_abre);
     Button1.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  funcao : Integer;
begin
  funcao := DriverGaveta(serial, GAVETA_ESTADO);
   if funcao = GAVETA_FECHADA then
        Label4.Caption := ' FECHADA '
   else
        Label4.Caption := ' ABERTA ';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   quantidade : integer;
   x          : integer;
   aberturas  : integer;
begin
  gauge1.progress := 0;
  gauge2.progress := 0;
  quantidade      := 0;
  aberturas       := 0;

  Timer1.Enabled  := False;
  Button1.Enabled := False;
  Button2.Enabled := False;
  Button3.Enabled := False;
  Button4.Enabled := False;

  while quantidade < 100 do
  begin
    Inc(quantidade);

    funcao := DriverGaveta (serial,Gaveta_abre);
    if funcao < 0 then
    begin
       gauge2.progress := gauge2.progress +1;
    end;

    x := 0;
    while x < 20000000 do
          begin
              Inc(x);
          end;
    FUNCAO := DriverGaveta (serial, Gaveta_Estado);
    if FUNCAO = 1 then
    begin
         Inc(aberturas);
         gauge1.progress := gauge1.progress +1;
    end;
  end;

  Timer1.Enabled  := True;
  Button1.Enabled := True;
  Button2.Enabled := True;
  Button3.Enabled := True;
  Button4.Enabled := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     DriverGaveta (serial, Gaveta_inicializa);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  FUNCAO := DriverGaveta (serial, Gaveta_Estado);
  if FUNCAO = 2 then
     label4.caption := ' ABERTA '
  else
     label4.caption := ' FECHADA ';
end;


end.
